%Guisinger, McCracken, & Owyang
%Reconsidering the Fed%s Inflation Forecasting Advantage

%%%%%%%
% Monetary Policy on the Path
%%%%%%%

FFR_q_table = readtable('PolicyMeasures_data_FFFappend_TKN.xlsx','Sheet','FFRq'); % Federal Funds Rate horizon 0 - 8 quaters ahead 

GB_FF_table1 = readtable('PolicyMeasures_data_FFFappend_TKN.xlsx','Sheet','GRFF');%GB forecasts horizon 0 - 8 quaters ahead, start - 2008:09
GB_FF_table2 = readtable('Greenbook_Financial_Assumptions_ShortRates_Web_update.xlsx','Sheet','FFR'); %GB forecasts horizon 0 - 8 quaters ahead, 2008:10 - 2014:12
GB_FF_table3 = readtable('greenbookdata/FFR_final.xlsx','Sheet','FFR');%GB forecasts horizon 0 - 8 quaters ahead, 2015:01 - 2016:12

%%%%%%%
% GB on the Path
% interval matches Quarterly data
% tau = 0.05
%%%%%%%

ACTUALq = FFR_q_table{13:444,2:10}; %Federal Funds Rate horizon 0-8 quaters ahead 1981M01 - 2016:12
GB_FF1 = GB_FF_table1{1:333,2:10}; %GB forecasts horizon 0-8 (in quaters) 1981M01 - 2008M09
GB_FF2 = GB_FF_table2{1:75,3:11}; %GB forecasts horizon 0-8 (in quaters) 2008:10 - 2014:12
GB_FF3 = GB_FF_table3{1:24,2:10}; %GB forecasts horizon 0-8 (in quaters) 2015:01 - 2016:12
GB_FF = [GB_FF1; GB_FF2; GB_FF3];

tau = 0.05;
T = size(GB_FF,1);
Date = GB_FF_table1{1:T,1};

GB_FF_top = zeros(T,9);
GB_FF_bot = zeros(T,9);
for h = 1 : 9
    if h==1 %h = 0 and h = 1 have the same bandwidth under this specification
        GB_FF_top(:,h) = GB_FF(:,h)* (1 + tau)^h;
        GB_FF_bot(:,h) = GB_FF(:,h)* (1 - tau)^h;
    else
        GB_FF_top(:,h) = GB_FF(:,h)* (1 + tau)^(h-1);
        GB_FF_bot(:,h) = GB_FF(:,h)* (1 - tau)^(h-1);
    end
end
GB_S05_q = (ACTUALq < GB_FF_top) .* (ACTUALq > GB_FF_bot);
GB_S05_q_t = array2table(GB_S05_q);
GB_S05_q_t = addvars(GB_S05_q_t,Date,'Before','GB_S05_q1');
writetable(GB_S05_q_t,'GB_FFR.xlsx','Sheet','GB_S05_q','WriteVariableNames',true);


%%%%%%%
% Greenbook Fed Funds Rate  - on Path
% once not on path, cannot be on path in the future
% interval matches Quarterly data
% tau = 0.05
%%%%%%%

GB_S05_q_MTO(:,1) = GB_S05_q(:,1);
for i = 1:T
    for h = 2:9
        GB_S05_q_MTO(i,h) = GB_S05_q_MTO(i,h-1) .* GB_S05_q(i,h);
    end
end
GB_S05_q_MTO_t = array2table(GB_S05_q_MTO);
x = addvars(GB_S05_q_MTO_t,Date,'Before','GB_S05_q_MTO1');
writetable(x,'GB_FFR.xlsx','Sheet','GB_S05_q_MTO','WriteVariableNames',true);

%Create Variables to use for Encompassing Regressions
%on path, quarterly
% 1 = acutal Fed Funds Rate is within range of futures
GB_S05_MTO_q_p = GB_S05_q_MTO(:,1:9);
GB_S05_MTO_q_p(GB_S05_MTO_q_p==0) = NaN;
GB_S05_MTO_q_p_t = array2table(GB_S05_MTO_q_p);
x = addvars(GB_S05_MTO_q_p_t,Date,'Before','GB_S05_MTO_q_p1');
writetable(x,'GB_FFR.xlsx','Sheet','GB_S05_MTO_q_p','WriteVariableNames',true);

%not on path, quarterly
GB_S05_MTO_q_np = GB_S05_q_MTO(:,1:9);
GB_S05_MTO_q_np(GB_S05_MTO_q_np==1) = -1;
GB_S05_MTO_q_np(GB_S05_MTO_q_np==0) = 1;
GB_S05_MTO_q_np(GB_S05_MTO_q_np==-1) = NaN;
GB_S05_MTO_q_np_t = array2table(GB_S05_MTO_q_np);
x = addvars(GB_S05_MTO_q_np_t,Date,'Before','GB_S05_MTO_q_np1');
writetable(x,'GB_FFR.xlsx','Sheet','GB_S05_MTO_q_np','WriteVariableNames',true);

