%Guisinger, McCracken, & Owyang
%Reconsidering the Fed%s Inflation Forecasting Advantage

%%%%%%%
% Monetary Policy on the Path
% 10Y GB
%%%%%%%

T10Y_q_table = readtable('PolicyMeasures_data_FFFappend_TKN.xlsx','Sheet','Act_10y_q'); % 10Y horizon 0 - 8 quaters ahead 

GB_10Y_table1 = readtable('PolicyMeasures_data_FFFappend_TKN.xlsx','Sheet','GR10YR');%GB forecasts horizon 0 - 8 quaters ahead, start - 2008:09
GB_10Y_table2 = readtable('greenbookdata/10YR_final.xlsx','Sheet','10YR');%GB forecasts horizon 0 - 8 quaters ahead, 2008:10 - 2016:12

%%%%%%%
% GB on the Path
% interval matches Quarterly data
% tau = 0.1
%%%%%%%

ACTUALq = T10Y_q_table{420:621,2:10}; %Federal Funds Rate horizon 0-7 quaters ahead 2003:03 - 2016:12
GB_10Y1 = GB_10Y_table1{231:333,2:10}; %GB forecasts horizon 0-7 (in quaters) 2000:03 - 2008M09
GB_10Y2 = GB_10Y_table2{1:99,2:10}; %GB forecasts horizon 0-7 (in quaters) 2008:10 - 2016:12
GB_10Y = [GB_10Y1; GB_10Y2];

tau = 0.1;
T = size(GB_10Y,1);
Date = T10Y_q_table{420:621,1};

GB_FF_top = zeros(T,9);
GB_FF_bot = zeros(T,9);
for h = 1 : 9
    if h==1 %h = 0 and h = 1 have the same bandwidth under this specification
        GB_FF_top(:,h) = GB_10Y(:,h)* (1 + tau)^h;
        GB_FF_bot(:,h) = GB_10Y(:,h)* (1 - tau)^h;
    else
        GB_FF_top(:,h) = GB_10Y(:,h)* (1 + tau)^(h-1);
        GB_FF_bot(:,h) = GB_10Y(:,h)* (1 - tau)^(h-1);
    end
end
GB10Y_S1_q = (ACTUALq < GB_FF_top) .* (ACTUALq > GB_FF_bot);
GB10Y_S1_q_t = array2table(GB10Y_S1_q);
GB10Y_S1_q_t = addvars(GB10Y_S1_q_t,Date,'Before','GB10Y_S1_q1');
writetable(GB10Y_S1_q_t,'GB10Y.xlsx','Sheet','GB10Y_S1_q','WriteVariableNames',true);


%%%%%%%
% Greenbook Fed Funds Rate  - on Path
% once not on path, cannot be on path in the future
% interval matches Quarterly data
% tau = 0.1
%%%%%%%

GB10Y_S1_q_MTO(:,1) = GB10Y_S1_q(:,1);
for i = 1:T
    for h = 2:9
        GB10Y_S1_q_MTO(i,h) = GB10Y_S1_q_MTO(i,h-1) .* GB10Y_S1_q(i,h);
    end
end
GB10Y_S1_q_MTO_t = array2table(GB10Y_S1_q_MTO);
x = addvars(GB10Y_S1_q_MTO_t,Date,'Before','GB10Y_S1_q_MTO1');
writetable(x,'GB10Y.xlsx','Sheet','GB10Y_S1_q_MTO','WriteVariableNames',true);

%Create Variables to use for Encompassing Regressions
%on path, quarterly
% 1 = acutal Fed Funds Rate is within range of futures
GB10Y_S1_MTO_q_p = GB10Y_S1_q_MTO(:,1:9);
GB10Y_S1_MTO_q_p(GB10Y_S1_MTO_q_p==0) = NaN;
GB10Y_S1_MTO_q_p_t = array2table(GB10Y_S1_MTO_q_p);
x = addvars(GB10Y_S1_MTO_q_p_t,Date,'Before','GB10Y_S1_MTO_q_p1');
writetable(x,'GB10Y.xlsx','Sheet','GB10Y_S1_MTO_q_p','WriteVariableNames',true);

%not on path, quarterly
GB10Y_S1_MTO_q_np = GB10Y_S1_q_MTO(:,1:9);
GB10Y_S1_MTO_q_np(GB10Y_S1_MTO_q_np==1) = -1;
GB10Y_S1_MTO_q_np(GB10Y_S1_MTO_q_np==0) = 1;
GB10Y_S1_MTO_q_np(GB10Y_S1_MTO_q_np==-1) = NaN;
GB10Y_S1_MTO_q_np_t = array2table(GB10Y_S1_MTO_q_np);
x = addvars(GB10Y_S1_MTO_q_np_t,Date,'Before','GB10Y_S1_MTO_q_np1');
writetable(x,'GB10Y.xlsx','Sheet','GB10Y_S1_MTO_q_np','WriteVariableNames',true);
