version 17.0
clear

capture log close
set more off

*Set the Directory
cd "/Users/guisinga/Dropbox/Research/Conditional Forecasts/Code/JMCB_Submission/Table6"

log using OaxcaBlinder.log, replace

/*
Table 6
Oaxca Blinder Decomposition

%Guisinger, McCracken, & Owyang
%Reconsidering the Fed%s Inflation Forecasting Advantage

*/

*install outreg2 if the first time
*ssc install outreg2


*********
*through 2016:12
* ZLB 10Y Tbill Futures & 10y Tbill Fed, tau = 0.1

*load data, h = 0
clear
import excel OB_data_stata_full_10yF.xlsx, sheet("h0") firstrow

*using ED & GB FFR forecast errors as information 
oaxaca fe_inf2 fe_ed_fed2 fe_u2 fe_y2, by(BC) noisily
outreg2 using Results_controls_10yF.doc, auto(3) title("Oaxaca Blinder - ZLB: 10y Futures & GB") replace


*load data, h = 1
clear
import excel OB_data_stata_full_10yF.xlsx, sheet("h1") firstrow

*using ED & GB FFR forecast errors as information 
oaxaca fe_inf2 fe_ed_fed2 fe_u2 fe_y2, by(BC) noisily
outreg2 using Results_controls_10yF.doc, auto(3) title("Oaxaca Blinder - ZLB: 10y Futures & GB") append

*load data, h = 2
clear
import excel OB_data_stata_full_10yF.xlsx, sheet("h2") firstrow

*using ED & GB FFR forecast errors as information 
oaxaca fe_inf2 fe_ed_fed2 fe_u2 fe_y2, by(BC) noisily
outreg2 using Results_controls_10yF.doc, auto(3) title("Oaxaca Blinder - ZLB: 10y Futures & GB") append

*load data, h = 3
clear
import excel OB_data_stata_full_10yF.xlsx, sheet("h3") firstrow

*using ED & GB FFR forecast errors as information 
oaxaca fe_inf2 fe_ed_fed2 fe_u2 fe_y2, by(BC) noisily
outreg2 using Results_controls_10yF.doc, auto(3) title("Oaxaca Blinder - ZLB: 10y Futures & GB") append

*load data, h = 4
clear
import excel OB_data_stata_full_10yF.xlsx, sheet("h4") firstrow

*using ED & GB FFR forecast errors as information 
oaxaca fe_inf2 fe_ed_fed2 fe_u2 fe_y2, by(BC) noisily
outreg2 using Results_controls_10yF.doc, auto(3) title("Oaxaca Blinder - ZLB: 10y Futures & GB") append

log close
